#include "CAlarmManager.h"
#include "../socket/TcpServer.h"
#include "../base_module/factory.h"

REGISTER_MODULE(CAlarmManager, "CAlarmManager")

CAlarmManager::CAlarmManager(QObject *parent)
    : QObject(parent),
      IModule(),
      m_pTcpModule(nullptr)
{
}

CAlarmManager::~CAlarmManager()
{
    std::cout << name() << std::endl;
}

//初始化操作
bool CAlarmManager::Initialize()
{
    //起主消息处理线程
    STARTUP_TASK(TaskMain)

    return true;
}

bool CAlarmManager::RegistMessage()
{
    m_pTcpModule = dynamic_cast<ITcpModule *>(QueryPlugin("TcpModule"));
    if (m_pTcpModule)
    {
        m_pTcpModule->RegistMessageCallback(this, MODULE_ALARM_MNG);
    }
    return true;
}

//主消息任务，主要用于和其他模块之间的消息通讯
void CAlarmManager::TaskMain(void *pBuff)
{
    (void)pBuff;
    setCurrentTaskName("tskAlarmMain");
    MODULE_MESSAGE *pMsg = nullptr;
    RegistMessage();
    waitForStart();

    //起主消息处理线程
    STARTUP_TASK(TaskSensorCol)

    while (!isShutdown())
    {
        if (GetModuleMessage(pMsg)) // get msg from message queue
        {
            switch (pMsg->iCmd)
            {
            // case CMD_ASK_FOR_SET_COLLECT_MODE:
            //     ProcSetModeRequest(pMsg);
            //     break;
            default:
                break;
            }

            SAFE_DELETE(pMsg);
        }
    }
}

//传感器收集任务, 用于定时轮询传感器相关的信息;
void CAlarmManager::TaskSensorCol(void *pBuff)
{
    (void)pBuff;
    while (this->isShutdown() == false)
    {
        //轮询sensor信息

        //给应用层发送消息,同步传感器信息
        MODULE_MESSAGE msg;
        msg.dst_id = (MODULE_ID)1;
        msg.dst_type = (APP_TYPE)1;
        msg.iCmd = (MODULE_COMMAND_ID)1;

        //模块间发送消息
        // m_pTcpModule->SendMsg(msg, sizeof(msg));
        //初步定在200ms每次,太长更新不及时,太短更新太快占用系统资源
        mSleep(200);
    }
}
