#ifndef CALARMMANAGER_H
#define CALARMMANAGER_H
#include "base_module.h"
#include <QObject>
#include <QDateTime>

class ITcpModule;

struct AlarmInfo
{
    AlarmInfo()
        :bAlarmEnd(false)
    {}

    QString toString()
    {
        return QString("%1|%2|%3|%4|%5|%6").arg(strAlarmName).arg(bAlarmEnd).arg(strLocation).arg(strExtention).arg(tmBegin.toString("yyyy-MM-dd hh:mm:ss")).arg(tmBegin.toString("yyyy-MM-dd hh:mm:ss"));
    }

    bool fromString(QString strAlarm)
    {
        QStringList list = strAlarm.split('|');
        if (list.size() == 6)
        {
            strAlarmName = list[0];
            bAlarmEnd = (bool)(list[1].toInt());
            strLocation = list[2];
            strExtention = list[3];
            tmBegin = QDateTime::fromString(list[4], "yyyy-MM-dd hh:mm:ss");
            tmEnd = QDateTime::fromString(list[5], "yyyy-MM-dd hh:mm:ss");
            return true;
        }
        return false;
    }

    QString strAlarmName;
    bool    bAlarmEnd;
    QString strLocation;
    QString strExtention;
    QDateTime tmBegin;
    QDateTime tmEnd;
};


class CAlarmManager : public QObject, public IModule
{
    Q_OBJECT
public:
    MODULE_NAME(CAlarmManager)
    explicit CAlarmManager(QObject *parent = nullptr);
    ~CAlarmManager();

    //初始化操作
    virtual bool Initialize();
    //模块注册接口
    bool RegistMessage();

Q_SIGNALS:
    //
    
public Q_SLOTS:

protected:
    //主消息任务，主要用于和其他模块之间的消息通讯
    THREAD_DEFINITION(CAlarmManager, TaskMain)
    //传感器收集任务, 用于定时轮询传感器相关的信息;
    THREAD_DEFINITION(CAlarmManager, TaskSensorCol)

    //主消息任务，主要用于和其他模块之间的消息通讯
    virtual void TaskMain(void *pBuff);
    //传感器收集任务, 用于定时轮询传感器相关的信息;
    virtual void TaskSensorCol(void *pBuff);

protected:
    ITcpModule*         m_pTcpModule;
};

#endif // CALARMMANAGER_H
