#ifndef CAUDIOMANAGER_H
#define CAUDIOMANAGER_H
#include "base_module.h"
#include <QObject>
#include <QDateTime>

class ITcpModule;
class CJT808Terminal;
class CDatebase;
class CConfigManager;

class CMcAdptManager : public QObject, public IModule
{
    Q_OBJECT
public:
    MODULE_NAME(CMcAdptManager)
    explicit CMcAdptManager(QObject *parent = nullptr);
    ~CMcAdptManager();

    //初始化操作
    virtual bool Initialize();
    //模块注册接口
    bool RegistMessage();

Q_SIGNALS:
    //
    void notifyAudioStatus(int);

public Q_SLOTS:

protected:
    //主消息任务，主要用于和其他模块之间的消息通讯
    THREAD_DEFINITION(CMcAdptManager, TaskMain)

    //主消息任务，主要用于和其他模块之间的消息通讯
    virtual void TaskMain(void *pBuff);

    // 处理获取配置
    void ProcGetAudioConfig(MODULE_MESSAGE &msg);

    // 处理上报麦克风状态
    void ProcRepAudioStatus(MODULE_MESSAGE &msg);

    // 获取麦克风状态
    void ProcGetMcStatus(MODULE_MESSAGE &msg);

    // 处理获取配置
    void regJt808CmdProc();

    // 下发配置到应用层
    void sendGetAudioConfig(QString config);

    // 初始化数据库
    bool InitializeDB();

    // 保存数据库
    bool saveConfig();

    /*******************************************
    函数功能: 下发麦克风配置
    入口参数: cycle_num 流水号
            payload 数据包
            lenth 长度
    出口参数:
    备    注:
    *******************************************/
    void procJt808SetMcConfig(int cycle_num, BYTE *payload, WORD lenth);

protected:
    ITcpModule *m_pTcpModule;
    int m_curAudioStatus;
    CJT808Terminal *m_pJt808Terminal;

    // 本地用户数据库
    CDatebase *m_pDbMic;
    CConfigManager *m_pConfigMng;

    // 状态上报未收到计数,累计3次将上报mc异常
    int m_iStatusRespCnt;
};

#endif // CAUDIOMANAGER_H
