#include "CRtmpResponser.h"
#include <QDebug>

CRtmpResponser::CRtmpResponser(QObject *parent) 
    : QObject(parent),
    pipeline(nullptr)
{

}

CRtmpResponser::~CRtmpResponser()
{
    stopRtmpRequire();
}

// 消息回调
gboolean CRtmpResponser::postGstMessage(GstBus * bus, GstMessage * message, gpointer user_data)
{
    (void) bus;
    (void) user_data;
    switch (GST_MESSAGE_TYPE(message))
    {
        case GST_MESSAGE_STATE_CHANGED:
        {
            break;
        }

        case GST_MESSAGE_TAG:
        {
            break;
        }
        case GST_MESSAGE_EOS:
        {
            break;
        }
        default:
            break;
    }
    return TRUE;
}

// 开时rtmp推流
bool CRtmpResponser::startRtmpRequire(QString strSrc, QString strRtmpSrv)
{
    if(pipeline)
    {
        return true;
    }

    QString gst_cmd = QString("gst-launch-1.0 -v rtspsrc location=\"%1\" latency=0 ! rtph264depay! h264parse ! flvmux ! rtmpsink location=\"%2\"").arg(strSrc).arg(strRtmpSrv);

    qDebug()<<"gst_parse_launch:"<<gst_cmd;
    pipeline = gst_parse_launch(gst_cmd.toStdString().c_str(), NULL);
    if(!pipeline)
    {
        return false;
    }

    // connect to interesting Q_SIGNALS
    GstBus *bus = gst_element_get_bus(pipeline);
    gst_bus_add_watch(bus, (GstBusFunc)postGstMessage, this);
    gst_object_unref(bus);

    // run the pipeline
    GstStateChangeReturn sret = gst_element_set_state (pipeline, GST_STATE_PLAYING);

    if (sret == GST_STATE_CHANGE_FAILURE)
    {
        gst_element_set_state (pipeline, GST_STATE_NULL);
        gst_object_unref (pipeline);
        pipeline = nullptr;
        return false;
    }

    return true;
}

// 停止rtmp推流
void CRtmpResponser::stopRtmpRequire()
{
    if(pipeline)
    {
        gst_element_set_state (pipeline, GST_STATE_NULL);
        gst_object_unref(pipeline);
        pipeline = nullptr;
    }
}
