#ifndef CKAFKAPRODUCER_H_
#define CKAFKAPRODUCER_H_

#pragma once
#include "librdkafka/rdkafka.h"

#include <thread>
#include "safe_queue.h"
#include <stdio.h>
#include <unistd.h>
#include <string.h>
typedef struct _kafkaMsg {
	char *msg;
	int size;
	
}kafkaMsg;





class CKafkaProducer
{
public:
 CKafkaProducer();
 ~CKafkaProducer();

int init(char *topic, char *brokers, int partition);
int sendMessage(char *str, int len);
int messagePushback(char* json_result,int json_len, char * jpg_char,int jpg_len);
//int messagePushback(char* json_result,int json_len);
int messagejsonPushback(char* json_result,int json_len);
void msgTask();
private:
	void terminateTaskThread();
private:	
	rd_kafka_t *                         m_kafka_handle;  //kafka消息生产者句柄
    rd_kafka_topic_t *                   m_kafka_topic;   //kafka消息主题名称
    rd_kafka_conf_t *                    m_kafka_conf;    //kafka消息配置
    rd_kafka_topic_conf_t *              m_kafka_topic_conf;
    rd_kafka_topic_partition_list_t *    m_kafka_topic_partition_list;
	std::thread * m_taskThread = nullptr;
    int m_partition;
	Queue<kafkaMsg *> m_msg_queue;
	bool stop = false;
};


#endif