#pragma once
#include <stdio.h>
#include <string.h>
#include <common.h>
#include <base_module.h>
#include <QVector>
#include <QMutex>

class DEVICE_IPC_INFO
{
public:
    char          hardware_type[128]; 
    char          DeviceName[64];
    char          DeviceID[128]; //uuid
    char          IP[32];
    int           Port;

    char          username[64];
    char          password[64];

    DEVICE_IPC_INFO()
    {
        memset(DeviceName, 0, sizeof(DeviceName));
        memset(DeviceID, 0, sizeof(DeviceID));
        memset(IP, 0, sizeof(IP));
        memset(hardware_type, 0, sizeof(hardware_type));
        Port = 80;
        memset(username, 0, sizeof(username));
        memset(password, 0, sizeof(password));
    }

    DEVICE_IPC_INFO& operator =(const DEVICE_IPC_INFO& t) 
    {
        strcpy(hardware_type, t.hardware_type);
        strcpy(DeviceName, t.DeviceName);
        strcpy(DeviceID, t.DeviceID);
        strcpy(IP, t.IP);
        Port = t.Port;
        strcpy(username, t.username);
        strcpy(password, t.password);

        return *this;
    }
};

typedef void (*DeviceDiscoverCB)(DEVICE_IPC_INFO * pInfo, void* lpContext);

class CWebCamFinder: public IModule
{
public:
    MODULE_NAME(CWebCamFinder)
    CWebCamFinder(void);
    ~CWebCamFinder(void);

    void SetDiscoveryInfoCB(DeviceDiscoverCB lpCallback, void*  lpContext);
    int  StartFind(void);
    void StopFind();

    //初始化操作
    virtual bool Initialize() {return true;}
    //消息接收任务；
    virtual void TaskMain(void *pBuff){(void)pBuff;}

    virtual bool RegistMessage(){ return true;}

protected:

    int probeSocketIni(int *fd, string szLocalIP);
    void probeSocketEnd(int *fd);
    int sendProbe(int fd,const char *uuid,const char *types);
    int recvProbeMatches(int fd,int timeout);

    void ReceivingLoop(void);
    
    // 当前搜索是否空闲
    bool isSearchIdel();

     int     m_fd;
     bool    m_bIsReceiving;

     DeviceDiscoverCB m_lpCallback;
     void*            m_lpContext;
     QVector<int>   m_vctFd;
     QMutex         m_mtxFd;
};
