#ifndef CPTZPARSER_H
#define CPTZPARSER_H
#pragma once
#include <string>
#include "../CSipDefs.h"

using namespace std;

namespace GB28181
{
    class CPtzParser
    {
    public:
        CPtzParser() = default;
        ~CPtzParser() = default;

        int ParseControlCmd(DEVICE_CONTROL_CMD &ctrlcmd, const string &cmdstr);

    private:
        void parse_ptz(const char *b, DEVICE_CONTROL_CMD &ctrlcmd);
        void parse_fi(const char *b, DEVICE_CONTROL_CMD &ctrlcmd);
        void parse_preset(const char *b, DEVICE_CONTROL_CMD &ctrlcmd);
        void parse_patrol(const char *b, DEVICE_CONTROL_CMD &ctrlcmd);
        void parse_scan(const char *b, DEVICE_CONTROL_CMD &ctrlcmd);

    private:
        uint8_t m_b4;
        uint8_t m_b5;
        uint8_t m_b6;
        uint8_t m_b7;
    };

}

#endif //CPTZPARSER_H
