#ifndef CXML_PARSER_H
#define CXML_PARSER_H
#pragma once
#include <tinyxml2.h>
#include "../CSipDefs.h"

using namespace std;

namespace GB28181
{
    typedef tinyxml2::XMLDocument tinyxml_doc_t;
    typedef tinyxml2::XMLElement tinyxml_ele_t;

    class CXmlParser
    {
    public:
        CXmlParser() = default;
        ~CXmlParser() = default;

        int Load(const char *p_data, int p_size, tinyxml_doc_t &doc);

        int ParseXmlHeader(tinyxml_doc_t &doc, MANSCDP_MSG_HEADER &bodyheader);

        int ParseEleStr(tinyxml_ele_t *ele, const char *name, string &textstr, bool brequired, bool bto_utf8 = false);

        int ParseEleInt(tinyxml_ele_t *ele, const char *name, int &value, bool brequired);

    private:
        int parse_cmdcategory(tinyxml_ele_t *ele, MANSCDP_CMD_CATEGORY &category, string &name);

        int parse_cmdtype(tinyxml_ele_t *ele, MANSCDP_MSG_HEADER &bh, string &textstr);

        //    int ParseEleStr(tinyxml_ele_t *ele, const char* name, string& textstr, bool brequired, bool bto_utf8= false);
        //
        //    int parse_ele_int(tinyxml_ele_t *ele, const char* name, int& value, bool brequired);

        int parse_ele_double(tinyxml_ele_t *ele, const char *name, double &value, bool brequired);

        bool is_member(tinyxml_ele_t *ele, const char *name);
    };

}
#endif //CXML_PARSER_H
