#ifndef CDMMMANAGER_H
#define CDMMMANAGER_H
#include "base_module.h"
#include <QObject>
#include <QDateTime>
#include "log/CLogManager.h"
#include "common.h"
class ITcpModule;
//class CJT808Terminal;
class CDatebase;
class CConfigManager;

class CdmmManager : public QObject, public IModule
{
    Q_OBJECT
public:
    MODULE_NAME(CdmmManager)
    explicit CdmmManager(QObject *parent = nullptr);
    ~CdmmManager();

    //初始化操作
    virtual bool Initialize();
    //模块注册接口
    bool RegistMessage();

Q_SIGNALS:
    //
    void notifyusbStatus(int);
	void notifycardStatus(int);
	void notifyhardStatus(int);
	void notifysoftStatus(int);
	void notifydisk(int);
	//void notifyaiStatus(int);
public Q_SLOTS:

protected:
    //主消息任务，主要用于和其他模块之间的消息通讯
    THREAD_DEFINITION(CdmmManager, TaskMain)

    //主消息任务，主要用于和其他模块之间的消息通讯
    virtual void TaskMain(void *pBuff);


    // 处理上报4g模块状态
    void ProcRep4GStatus(MODULE_MESSAGE &msg);
	void ProcRepcardStatus(MODULE_MESSAGE &msg);
	void ProcRephardStatus(MODULE_MESSAGE &msg);
	void ProcRepsoftStatus(MODULE_MESSAGE &msg);
    // 获取麦克风状态
    void ProcGet4Gtatus(MODULE_MESSAGE &msg);
	void ProcGetcardtatus(MODULE_MESSAGE &msg);
	void ProcGethardtatus(MODULE_MESSAGE &msg);
	void ProcGetsofttatus(MODULE_MESSAGE &msg);
protected:
    ITcpModule *m_pTcpModule;
    int m_usbStatus;//usb模块
    // 本地用户数据库
	int m_cardStatus;//card 状态
	int m_hardnet;//虚拟网卡是否存在
	int m_softnet;// 实现是否有网 ping baidu
    // 状态上报未收到计数,累计3次将上报mc异常
    int m_iStatusRespCnt;
};

#endif // CDMMMANAGER_H
