#ifndef UART_IF_H
#define UART_IF_H
#include <fcntl.h>

int UART_Open(const char *port, int flag = O_RDWR);
void UART_Close(int fd);
int UART_Set(int fd, int speed = 115200, int flow_ctrl = 0, int databits = 8, int stopbits = 1, char parity = 'N');
int UART_Init(int fd, int speed = 115200, int flow_ctrl = 0, int databits = 8, int stopbits = 1, char parity = 'N');
int UART_Recv(int fd, char *rcv_buf, int data_len);
int UART_Send(int fd, const unsigned char *send_buf, int data_len);
unsigned short CRC16(unsigned char *p, unsigned short datalen);

#endif // UART_IF_H
