#include "CJt808AreaRoute.h"
#include <QDebug>

// 检查是否在区域内
bool Cjt808Area::isGpsContain(QPoint pt)
{
    return true;
}
// 检查是否处于限制时间段
bool Cjt808Area::isTimeContain()
{
    return true;
}
// 检查是否超速(白天/晚上)
bool Cjt808Area::isOverSpeed()
{
    return true;
}
// 检查是否超速时长越限
bool Cjt808Area::isOverSpeedTimeExceed()
{
    return true;
}

// 是否已经上报
bool Cjt808Area::isReported()
{
    return true;
}

// 检查是否在区域内
bool CircularArea::isGpsContain(QPoint pt)
{
}

// 检查是否在区域内
bool RectangleArea::isGpsContain(QPoint pt)
{
    return true;
}

// 检查是否在区域内
bool PolygonalArea::isGpsContain(QPoint pt)
{
    return true;
}

CJt808AreaRoute::CJt808AreaRoute()
{
}

CJt808AreaRoute::~CJt808AreaRoute()
{
}
/*******************************************
函数功能: 设置圆形区域
入口参数: data 数据包
        lenth 长度
出口参数:
备    注:
*******************************************/
void CJt808AreaRoute::procSetAreaRound(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--设置圆形区域";

    int idx = 0;
    AreaOperation operate_type = (AreaOperation)payload[idx++];
    int area_cnt = payload[idx++];

    for (int i = 0; i < area_cnt && idx < MAX_JT808_FRAMEBUF_LEN_V1; i++)
    {
        CircularArea area;
        area.area_id = four_char_to_long(&payload[idx]);
        idx += 4;
        memcpy(&area.area_attribute, &payload[idx], 2);
        idx += 2;
        area.center_point.setY(four_char_to_long(&payload[idx]));
        idx += 4;
        area.center_point.setX(four_char_to_long(&payload[idx]));
        idx += 4;
        bcd2time(&payload[idx], area.start_time);
        idx += 6;
        bcd2time(&payload[idx], area.end_time);
        idx += 6;
        area.max_speed = two_char_to_short(&payload[idx]);
        idx += 2;
        area.overspeed_duration = payload[idx++];
        area.max_speed_night = two_char_to_short(&payload[idx]);
        idx += 2;
        area.name_len = two_char_to_short(&payload[idx]);
        idx += 2;
        area.area_name = std::string(payload[idx], area.name_len);

        CYCLE_AREA_MAP::iterator it = m_mapCycleArea.find(area.area_id);
        m_mapCycleArea[area.area_id] = area;
    }

    qDebug() << "-->>设置圆形区域应答";
    sendCommonAnswer(cycle_num, SERVER_SET_AREA_ROUND, 0);
}

/*******************************************
函数功能: 删除圆形区域
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
void CJt808AreaRoute::procDelAreaRound(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--删除圆形区域";
    int idx = 0;
    int area_cnt = payload[idx++];
    DWORD area_id = 0;

    for (int i = 0; i < area_cnt && idx < MAX_JT808_FRAMEBUF_LEN_V1; i++)
    {
        area_id = four_char_to_long(&payload[idx]);
        idx += 4;
        m_mapCycleArea.remove(area_id);
    }

    qDebug() << "-->>删除圆形区域应答";
    sendCommonAnswer(cycle_num, SERVER_DEL_AREA_ROUND, 0);
}

/*******************************************
函数功能: 设置矩形区域
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
void CJt808AreaRoute::procSetAreaRect(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--设置矩形区域";
    int idx = 0;
    AreaOperation operate_type = (AreaOperation)payload[idx++];
    int area_cnt = payload[idx++];

    for (int i = 0; i < area_cnt && idx < MAX_JT808_FRAMEBUF_LEN_V1; i++)
    {
        RectangleArea area;
        area.area_id = four_char_to_long(&payload[idx]);
        idx += 4;
        memcpy(&area.area_attribute, &payload[idx], 2);
        idx += 2;
        area.upper_left_corner.setY(four_char_to_long(&payload[idx]));
        idx += 4;
        area.upper_left_corner.setX(four_char_to_long(&payload[idx]));
        idx += 4;
        area.bottom_right_corner.setY(four_char_to_long(&payload[idx]));
        idx += 4;
        area.bottom_right_corner.setX(four_char_to_long(&payload[idx]));
        idx += 4;
        bcd2time(&payload[idx], area.start_time);
        idx += 6;
        bcd2time(&payload[idx], area.end_time);
        idx += 6;
        area.max_speed = two_char_to_short(&payload[idx]);
        idx += 2;
        area.overspeed_duration = payload[idx++];
        area.max_speed_night = two_char_to_short(&payload[idx]);
        idx += 2;
        area.name_len = two_char_to_short(&payload[idx]);
        idx += 2;
        area.area_name = std::string(payload[idx], area.name_len);

        RECT_AREA_MAP::iterator it = m_mapRectArea.find(area.area_id);
        m_mapRectArea[area.area_id] = area;
    }

    qDebug() << "-->>设置矩形区域应答";
    sendCommonAnswer(cycle_num, SERVER_SET_AREA_RECT, 0);
}

/*******************************************
函数功能: 删除矩形区域
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
void CJt808AreaRoute::procDelAreaRect(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--删除矩形区域";
    int idx = 0;
    int area_cnt = payload[idx++];
    DWORD area_id = 0;

    for (int i = 0; i < area_cnt && idx < MAX_JT808_FRAMEBUF_LEN_V1; i++)
    {
        area_id = four_char_to_long(&payload[idx]);
        idx += 4;
        m_mapRectArea.remove(area_id);
    }

    qDebug() << "-->>删除矩形区域应答";
    sendCommonAnswer(cycle_num, SERVER_DEL_AREA_RECT, 0);
}

/*******************************************
函数功能: 设置多边形区域
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
void CJt808AreaRoute::procSetAreaPolygon(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--设置多边形区域";
    int idx = 0;
    PolygonalArea area;
    area.area_id = four_char_to_long(&payload[idx]);
    idx += 4;
    memcpy(&area.area_attribute, &payload[idx], 2);
    idx += 2;
    bcd2time(&payload[idx], area.start_time);
    idx += 6;
    bcd2time(&payload[idx], area.end_time);
    idx += 6;
    area.max_speed = two_char_to_short(&payload[idx]);
    idx += 2;
    area.overspeed_duration = payload[idx++];

    int pt_count = two_char_to_short(&payload[idx]);
    idx += 2;
    for (int j = 0; j < pt_count; j++)
    {
        QPoint pt;
        pt.setY(four_char_to_long(&payload[idx]));
        idx += 4;
        pt.setX(four_char_to_long(&payload[idx]));
        idx += 4;
        area.polygon.append(pt);
    }

    area.max_speed_night = two_char_to_short(&payload[idx]);
    idx += 2;
    area.name_len = two_char_to_short(&payload[idx]);
    idx += 2;
    area.area_name = std::string(payload[idx], area.name_len);

    POLYGON_AREA_MAP::iterator it = m_mapPolygonArea.find(area.area_id);
    m_mapPolygonArea[area.area_id] = area;

    qDebug() << "-->>设置多边形区域应答";
    sendCommonAnswer(cycle_num, SERVER_SET_AREA_POLYGON, 0);
}

/*******************************************
函数功能: 删除多边形区域
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
void CJt808AreaRoute::procDelAreaPolygon(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--删除多边形区域";
    int idx = 0;
    int area_cnt = payload[idx++];
    DWORD area_id = 0;

    for (int i = 0; i < area_cnt && idx < MAX_JT808_FRAMEBUF_LEN_V1; i++)
    {
        area_id = four_char_to_long(&payload[idx]);
        idx += 4;
        m_mapPolygonArea.remove(area_id);
    }

    qDebug() << "-->>删除多边形区域应答";
    sendCommonAnswer(cycle_num, SERVER_DEL_AREA_POLYGON, 0);
}

/*******************************************
函数功能: 设置路线
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
void CJt808AreaRoute::procSetAreaRoute(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--设置路线";
    int idx = 0;
    Route route;
    route.route_id = four_char_to_long(&payload[idx]);
    idx += 4;
    memcpy(&route.route_attribute, &payload[idx], 2);
    idx += 2;
    bcd2time(&payload[idx], route.start_time);
    idx += 6;
    bcd2time(&payload[idx], route.end_time);
    idx += 6;

    int pt_count = two_char_to_short(&payload[idx]);
    idx += 2;
    for (int j = 0; j < pt_count; j++)
    {
        InflectionPoint inf_pt;
        inf_pt.inflection_point_id = four_char_to_long(&payload[idx]);
        idx += 4;
        inf_pt.road_section_id = four_char_to_long(&payload[idx]);
        idx += 4;

        inf_pt.coordinate.setY(four_char_to_long(&payload[idx]));
        idx += 4;
        inf_pt.coordinate.setX(four_char_to_long(&payload[idx]));
        idx += 4;

        inf_pt.road_section_wide = payload[idx++];
        inf_pt.max_driving_time = two_char_to_short(&payload[idx]);
        idx += 2;
        inf_pt.min_driving_time = two_char_to_short(&payload[idx]);
        idx += 2;

        inf_pt.max_speed = two_char_to_short(&payload[idx]);
        idx += 2;

        inf_pt.max_driving_time = payload[idx++];

        inf_pt.max_speed_night = two_char_to_short(&payload[idx]);
        idx += 2;

        route.inflection_point_list.push_back(inf_pt);
        route.inflection_point_count++;
    }

    route.name_len = two_char_to_short(&payload[idx]);
    idx += 2;
    route.route_name = std::string(payload[idx], route.name_len);

    m_mapRoute[route.route_id] = route;

    qDebug() << "-->>设置路线应答";
    sendCommonAnswer(cycle_num, SERVER_SET_AREA_ROUTE, 0);
}

/*******************************************
函数功能: 删除线路
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
void CJt808AreaRoute::procDleAreaRoute(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--删除线路";
    int idx = 0;
    int route_cnt = payload[idx++];
    DWORD route_id = 0;

    for (int i = 0; i < route_cnt && idx < MAX_JT808_FRAMEBUF_LEN_V1; i++)
    {
        route_id = four_char_to_long(&payload[idx]);
        idx += 4;
        m_mapRoute.remove(route_id);
    }

    qDebug() << "-->>删除线路应答";
    sendCommonAnswer(cycle_num, SERVER_DEL_AREA_ROUTE, 0);
}

/*******************************************
函数功能: 查询线路或区域信息
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
void CJt808AreaRoute::procQueryAreaInfo(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--查询线路或区域信息";

    QByteArray ba(4000, 0);
    BYTE *send_data = (BYTE *)ba.data();
    int idx = 0;
    BYTE type = payload[idx++];
    DWORD count = four_char_to_long(&payload[idx]);
    DWORD rsp_cnt = 0;
    idx += 4;

    for (int i = 0; i < count && idx < MAX_JT808_FRAMEBUF_LEN_V1; i++)
    {
        DWORD id = four_char_to_long(&payload[idx]);
        idx += 4;
        switch (type)
        {
        case 1: /* 圆形区域 */
        {
            auto it = m_mapCycleArea.find(id);
            if (it != m_mapCycleArea.end())
            {
                auto &area = it.value();
                long_to_four_char(area.area_id, &payload[idx]);
                idx += 4;
                memcpy(&payload[idx], &area.area_attribute, 2);
                idx += 2;
                long_to_four_char(area.center_point.y(), &payload[idx]);
                idx += 4;
                long_to_four_char(area.center_point.x(), &payload[idx]);
                idx += 4;
                time2bcd(area.start_time, &payload[idx]);
                idx += 6;
                time2bcd(area.end_time, &payload[idx]);
                idx += 6;
                short_to_two_char(area.max_speed, &payload[idx]);
                idx += 2;
                payload[idx++] = area.overspeed_duration;
                short_to_two_char(area.max_speed_night, &payload[idx]);
                idx += 2;
                short_to_two_char(area.name_len, &payload[idx]);
                idx += 2;
                memcpy(&payload[idx], area.area_name.c_str(), area.name_len);
                idx += area.name_len;
                rsp_cnt++;
            }
            break;
        }
        case 2: /* 矩形区域 */
        {
            auto it = m_mapRectArea.find(id);
            if (it != m_mapRectArea.end())
            {
                auto &area = it.value();
                long_to_four_char(area.area_id, &payload[idx]);
                idx += 4;
                memcpy(&payload[idx], &area.area_attribute, 2);
                idx += 2;
                long_to_four_char(area.upper_left_corner.y(), &payload[idx]);
                idx += 4;
                long_to_four_char(area.upper_left_corner.x(), &payload[idx]);
                idx += 4;
                long_to_four_char(area.bottom_right_corner.y(), &payload[idx]);
                idx += 4;
                long_to_four_char(area.bottom_right_corner.x(), &payload[idx]);
                idx += 4;
                time2bcd(area.start_time, &payload[idx]);
                idx += 6;
                time2bcd(area.end_time, &payload[idx]);
                idx += 6;
                short_to_two_char(area.max_speed, &payload[idx]);
                idx += 2;
                payload[idx++] = area.overspeed_duration;
                short_to_two_char(area.max_speed_night, &payload[idx]);
                idx += 2;
                short_to_two_char(area.name_len, &payload[idx]);
                idx += 2;
                memcpy(&payload[idx], area.area_name.c_str(), area.name_len);
                idx += area.name_len;
                rsp_cnt++;
            }
            break;
        }
        case 3: /* 多边形区域 */
        {
            auto it = m_mapPolygonArea.find(id);
            if (it != m_mapPolygonArea.end())
            {
                auto &area = it.value();
                long_to_four_char(area.area_id, &payload[idx]);
                idx += 4;
                memcpy(&payload[idx], &area.area_attribute, 2);
                idx += 2;
                time2bcd(area.start_time, &payload[idx]);
                idx += 6;
                time2bcd(area.end_time, &payload[idx]);
                idx += 6;
                short_to_two_char(area.max_speed, &payload[idx]);
                idx += 2;
                payload[idx++] = area.overspeed_duration;

                short_to_two_char(area.polygon.size(), &payload[idx]);
                idx += 2;
                for (int j = 0; j < area.polygon.size(); j++)
                {
                    long_to_four_char(area.polygon.at(j).y(), &payload[idx]);
                    idx += 4;
                    long_to_four_char(area.polygon.at(j).x(), &payload[idx]);
                    idx += 4;
                }

                short_to_two_char(area.max_speed_night, &payload[idx]);
                idx += 2;
                short_to_two_char(area.name_len, &payload[idx]);
                idx += 2;
                memcpy(&payload[idx], area.area_name.c_str(), area.name_len);
                idx += area.name_len;
                rsp_cnt++;
            }
            break;
        }
        case 4: /* 路径 */
        {
            auto it = m_mapRoute.find(id);
            if (it != m_mapRoute.end())
            {
                auto &route = it.value();
                long_to_four_char(route.route_id, &payload[idx]);
                idx += 4;
                memcpy(&payload[idx], &route.route_attribute, 2);
                idx += 2;
                time2bcd(route.start_time, &payload[idx]);
                idx += 6;
                time2bcd(route.end_time, &payload[idx]);
                idx += 6;

                short_to_two_char(route.inflection_point_list.size(), &payload[idx]);
                idx += 2;

                for (int j = 0; j < route.inflection_point_list.size(); j++)
                {
                    auto inf_pt = route.inflection_point_list[j];
                    long_to_four_char(inf_pt.inflection_point_id, &payload[idx]);
                    idx += 4;
                    long_to_four_char(inf_pt.road_section_id, &payload[idx]);
                    idx += 4;

                    long_to_four_char(inf_pt.coordinate.y(), &payload[idx]);
                    idx += 4;
                    long_to_four_char(inf_pt.coordinate.x(), &payload[idx]);
                    idx += 4;
                    payload[idx++] = inf_pt.road_section_wide;
                    payload[idx++] = inf_pt.road_section_attribute.value;

                    short_to_two_char(inf_pt.max_driving_time, &payload[idx]);
                    idx += 2;
                    short_to_two_char(inf_pt.min_driving_time, &payload[idx]);
                    idx += 2;

                    short_to_two_char(inf_pt.max_speed, &payload[idx]);
                    idx += 2;
                    payload[idx++] = inf_pt.overspeed_duration;
                    short_to_two_char(inf_pt.max_speed_night, &payload[idx]);
                    idx += 2;
                }

                short_to_two_char(route.name_len, &payload[idx]);
                idx += 2;
                memcpy(&payload[idx], route.route_name.c_str(), route.name_len);
                idx += route.name_len;
                rsp_cnt++;
            }
            break;
        }
        break;
        }
    }

    int idx_rsp = 0;
    send_data[idx_rsp++] = type;
    long_to_four_char(rsp_cnt, &send_data[idx_rsp]);
    idx_rsp += 4;
    qDebug() << "-->>查询线路或区域信息应答";
    sendPayload2Jt808Serv(TERMINAL_AERA_INFO_ANSWER, send_data, idx_rsp);
}

/*******************************************
函数功能: 电子围栏检查
入口参数:
出口参数:
备    注:
*******************************************/
void CJt808AreaRoute::eFenceCheck()
{
    // 遍历圆形区域
    // 遍历矩形区域
    // 遍历多边形区域
    // 遍历路线
}
