#include "CJt808Information.h"
#include <QDebug>

CJt808Information::CJt808Information()
{
}

/*******************************************
函数功能: 事件设置
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
WORD CJt808Information::procSetEvent(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--事件设置下发";
    BYTE type = payload[0];

    qDebug() << "-->>事件设置应答";
    sendCommonAnswer(cycle_num, SERVER_EVENT_SET, 0);

    // 下面是测试代码 模拟开始和取消，因为是废弃命令，这里只作测试。
    //    mSleep(200);
    //    int idx = 0;
    //    payload[idx++] = 0;
    //    idx = msg.generateMsg(TERMINAL_EVENT_REPORT, idx);
    //    sendJt808Msg2Serv(msg.m_pbyBuffer, idx);
}

/*******************************************
函数功能: 提问下发
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
WORD CJt808Information::procAskQuestion(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "-->>提问下发应答";
    QByteArray ba(1000, 0);
    BYTE *send_data = (BYTE *)ba.data();
    int idx = 0;
    /* 应答流水号 */
    short_to_two_char(cycle_num, &send_data[idx]);
    idx += 2;
    std::string info = "设备不支持2019版本中废弃的命令";
    strncpy((char *)&send_data[idx], info.c_str(), info.length());
    idx += info.length() + 1;
    sendPayload2Jt808Serv(TERMINAL_RETURN_ANSWER, send_data, idx);
}

/*******************************************
函数功能: 信息点播菜单设置
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
WORD CJt808Information::procSetOrderMenu(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--信息点播菜单设置下发";
    BYTE type = payload[0];
    qDebug() << "-->>信息点播菜单设置应答";
    sendCommonAnswer(cycle_num, SERVER_SEND_ODER, 0);

    // TODO
    // // 下面是测试代码 模拟开始和取消，因为是废弃命令，这里只作测试。
    // mSleep(200);
    // int idx = 0;
    // payload[idx++] = 0;
    // payload[idx++] = 1;
    // idx = msg.generateMsg(TERMINAL_RETURN_ODER, idx);
    // sendJt808Msg2Serv(msg.m_pbyBuffer, idx);

    // mSleep(200);
    // idx = 1;
    // payload[idx++] = 0;
    // idx = msg.generateMsg(TERMINAL_RETURN_ODER, idx);
    // sendJt808Msg2Serv(msg.m_pbyBuffer, idx);
}

/*******************************************
函数功能: 信息服务
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
WORD CJt808Information::procInfoServ(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--信息服务下发";
    int idx = 0;

    qDebug() << "-->>信息服务应答";
    sendCommonAnswer(cycle_num, SERVER_SEND_MSG, 0);
}

/*******************************************
函数功能: 文本下发
入口参数: data 数据包
            lenth 长度
出口参数:
备    注:
*******************************************/
WORD CJt808Information::procSendText(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--文本信息下发";
    int idx = 0;

    // 这里可能需要将文本信息显示到主屏幕并提示信息，这个命令是信息服务里面唯一的没有废弃的命令

    qDebug() << "-->>文本信息下发应答";
    sendCommonAnswer(cycle_num, SERVER_SEND_TEXT, 0);
}
