#ifndef CJT808INFORMATION_H
#define CJT808INFORMATION_H
#include "common.h"
#include "jt808_msg.h"
#include "jt808_common.h"

// 在2019版本中信息类服务被丢弃，这里不做判断直接返回空，保留功能完整性
class CJt808Information
{
public:
    CJt808Information();
    virtual ~CJt808Information(){}

protected:
    /*******************************************
    函数功能: 发送数据到JT08服务器
    入口参数: WORD cmd,       命令字
            BYTE *payload,  净荷
            WORD lenth      净荷长度
    出口参数:
    备    注:
    *******************************************/
    virtual WORD sendPayload2Jt808Serv(WORD cmd, BYTE *payload, WORD lenth) = 0;

    /*******************************************
    函数功能: 发送通用应答
    入口参数: cycle_num 流水号
             id  消息ID
             result 执行结果
    出口参数:
    备    注:
    *******************************************/
    virtual WORD sendCommonAnswer(WORD cycle_num, WORD id, BYTE result) = 0;

    /*******************************************
    函数功能: 事件设置
    入口参数: data 数据包
             lenth 长度
    出口参数:
    备    注:
    *******************************************/
    virtual WORD procSetEvent(int cycle_num, BYTE *payload, WORD lenth);

    /*******************************************
    函数功能: 提问下发
    入口参数: data 数据包
             lenth 长度
    出口参数:
    备    注:
    *******************************************/
    virtual WORD procAskQuestion(int cycle_num, BYTE *payload, WORD lenth);

    /*******************************************
    函数功能: 信息点播菜单设置
    入口参数: data 数据包
             lenth 长度
    出口参数:
    备    注:
    *******************************************/
    virtual WORD procSetOrderMenu(int cycle_num, BYTE *payload, WORD lenth);

    /*******************************************
    函数功能: 信息服务
    入口参数: data 数据包
             lenth 长度
    出口参数:
    备    注:
    *******************************************/
    virtual WORD procInfoServ(int cycle_num, BYTE *payload, WORD lenth);

    /*******************************************
    函数功能: 文本下发
    入口参数: data 数据包
            lenth 长度
    出口参数:
    备    注:
    *******************************************/
    virtual WORD procSendText(int cycle_num, BYTE *payload, WORD lenth);
};

#endif // CJT808INFORMATION_H
