#include "CJt808Media.h"
#include <QDebug>
#include <QBuffer>
#include "socket/TcpModule.h"
#include "file/CFileManager.h"
#include <QVector>

CJt808Media::CJt808Media()
{
}

/*******************************************
函数功能: 多媒体上传应答
入口参数: data 数据包
        lenth 长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procMediaReq(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--多媒体上传应答";
    int idx = 0;
    // 多媒体ID
    DWORD media_id = four_char_to_long(&payload[idx]);
    idx += 4;
    // 重传包总数
    BYTE pkg_idx = payload[idx++];
    // 重传包列表
    for (size_t i = 0; i < pkg_idx; i++)
    {
        // 重传包ID
        WORD id = two_char_to_short(&payload[idx]);
        idx += 2;
    }

    // 多媒体分包重传

    qDebug() << "-->>多媒体上传应答回复";
    sendCommonAnswer(cycle_num, SERVER_MEDIA_RETURN, 0);
}

/*******************************************
函数功能: 拍照
入口参数: data 数据包
        lenth 长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procTakePicture(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--拍照";
    int idx = 0;
    // 通道
    BYTE channel = payload[idx++];
    // 命令 停止拍摄(0) 录像(0xFFFF) 其他(拍照张数)
    WORD cmd = two_char_to_short(&payload[idx]);
    idx += 2;
    // 间隔
    WORD interval = two_char_to_short(&payload[idx]);
    idx += 2;
    // 根据协议规定，如果终端不支持要求的分辨率和类型，取终端能够支持的最接近的分辨率拍照上传
    // 分辨率
    BYTE pix_type = payload[idx++];
    // 图像质量
    BYTE quality = payload[idx++];
    // 亮度
    BYTE light_rat = payload[idx++];
    // 对比度
    BYTE contrast_rat = payload[idx++];
    // 饱和度
    BYTE saturation_rat = payload[idx++];
    // 色度
    BYTE quality_rat = payload[idx++];

    // TO1 以下为测试代码,实际代码需要转发到相机模块处理
    DWORD dwArray[1] = {1};
    RspTakePicture(cycle_num, 1, &dwArray[0]);
}

/*******************************************
函数功能: 拍照应答
入口参数: data 数据包
        lenth 长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::RspTakePicture(WORD cycl_num, int count, DWORD *pArray)
{
    qDebug() << "<<--拍照";
    QByteArray ba(4000, 0);
    BYTE *payload = (BYTE *)ba.data();
    int idx = 0;
    // 流水号
    short_to_two_char(cycl_num, &payload[idx]);
    // ID个数
    payload[idx++] = 1;
    // ID
    for (int i = 0; i < count; i++)
    {
        long_to_four_char(pArray[i], &payload[idx]);
        idx += 4;
    }

    qDebug() << "-->>拍照响应";
    sendPayload2Jt808Serv(TERMINAL_TAKE_PICTURE_ANSWER, payload, idx);
}

/*******************************************
    函数功能: 存储多媒体数据检索
    入口参数: data 数据包
         lenth 长度
    出口参数:
    备    注:
    *******************************************/
WORD CJt808Media::procCheckMedia(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--存储多媒体数据检索";
    int idx = 0;
    // 类型 图像(1) 音频(2) 视频(3)
    BYTE type = payload[idx++];
    // 通道ID 0表示所有
    BYTE channel = payload[idx++];
    // 事件编码 平台下发指令(0) 定时动作(1) 抢劫报警触发(2) 碰撞侧翻触发(3) 其他
    BYTE event = payload[idx++];

    BYTE tm_begin[6], tm_end[6];
    // 开始时间
    bcd2time(&payload[idx], tm_begin);
    idx += 6;
    // 结束时间
    bcd2time(&payload[idx], tm_end);
    idx += 6;

    // 开始检索数据；
    int count = 0;

    qDebug() << "-->>存储多媒体数据检索应答";
    QByteArray ba(4000, 0);
    BYTE *send_data = (BYTE *)ba.data();
    idx = 0;
    // 流水号
    short_to_two_char(cycle_num, &send_data[idx]);
    idx += 2;
    // 媒体数量
    short_to_two_char(count, &send_data[idx]);
    idx += 2;

    // 检索项
    for (int i = 0; i < count; i++)
    {
        // ID
        long_to_four_char(0, &send_data[idx]);
        idx += 4;
        // 类型
        send_data[idx++] = type;
        // 通道
        send_data[idx++] = channel;
        // 事件
        send_data[idx++] = event;
        // 位置信息 0x200的位置信息
        GPS_INFO gps;
        idx += fillLocationInfo(&send_data[idx], gps);
    }

    sendPayload2Jt808Serv(TERMINAL_MEDIA_CHECK_RETURN, send_data, idx);
}

/*******************************************
函数功能: 媒体数据上传
入口参数: data 数据包
        lenth 长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procReadMedia(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--媒体数据上传";
    int idx = 0;

    // 类型 图像(1) 音频(2) 视频(3)
    BYTE type = payload[idx++];
    // 通道ID 0表示所有
    BYTE channel = payload[idx++];
    // 事件编码 平台下发指令(0) 定时动作(1) 抢劫报警触发(2) 碰撞侧翻触发(3) 其他
    BYTE event = payload[idx++];

    BYTE tm_begin[6], tm_end[6];
    // 开始时间
    bcd2time(&payload[idx], (BYTE *)&tm_begin);
    idx += 6;
    // 结束时间
    bcd2time(&payload[idx], (BYTE *)&tm_end);
    idx += 6;

    // 删除标记 保留(0) 删除(1)
    BYTE del_flag = payload[idx++];

    // 处理代码

    qDebug() << "-->>媒体数据上传应答";
    sendCommonAnswer(cycle_num, SERVER_READ_MEDIA, 0);
}

/*******************************************
函数功能: 开始录音
入口参数: data 数据包
        lenth 长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procStartRecordSound(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--开始录音";
    int idx = 0;

    // 录音命令 停止录音(0) 开始录音(1)
    BYTE cmd = payload[idx++];
    // 录音时间(s)
    WORD seconds = two_char_to_short(&payload[idx]);
    idx += 2;
    // 保存标志 实时上传(0) 保存本地(1)
    BYTE save_flag = payload[idx++];
    //音频采样率 8K(0) 11K(1) 23K(2) 32K(3) 其他
    BYTE freq = payload[idx++];

    // 处理代码

    qDebug() << "-->>开始录音应答";
    sendCommonAnswer(cycle_num, SERVER_RECORD_SOUND, 0);
}

/*******************************************
函数功能: 单条多媒体数据检索上传
入口参数: data 数据包
        lenth 长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procUploadMediadata(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--单条多媒体数据检索上传";
    int idx = 0;
    // 多媒体ID
    DWORD dwID = four_char_to_long(&payload[idx]);
    idx += 4;
    // 删除标记 保留(0) 删除(1)
    BYTE del_flag = payload[idx++];

    // 处理代码

    qDebug() << "-->>单条多媒体数据检索上传应答";
    sendCommonAnswer(cycle_num, SERVER_UPLOAD_MEDIADATA, 0);
}

/*******************************************
函数功能: 多媒体数据上传
入口参数: MediaData &media_data 多媒体信息
出口参数:
备    注:
*******************************************/
WORD CJt808Media::sendMediaData(MediaData &media_data)
{
    QByteArray ba(4000, 0);
    BYTE *send_data = (BYTE *)ba.data();
    int idx = 0;
    // 多媒体数据ID（DWORD）
    long_to_four_char(media_data.event.media_id, &send_data[idx]);
    idx += 4;
    // 多媒体类型 BYTE
    send_data[idx++] = media_data.event.media_type;
    // 多媒体格式编码 BYTE
    send_data[idx++] = media_data.event.media_code;
    // 事件编码 BYTE
    send_data[idx++] = media_data.event.event_type;
    // 通道ID BYTE
    send_data[idx++] = media_data.event.channel;

    // gps信息
    idx += fillLocationInfo(&send_data[idx], media_data.gps);

    // 媒体内容

    qDebug() << "-->>多媒体事件上报";
    sendPayload2Jt808Serv(TERMINAL_UP_MEDIA, send_data, idx);
}

/*******************************************
函数功能: 多媒体数据上传
入口参数: MediaEvent &event 多媒体事件
出口参数:
备    注:
*******************************************/
WORD CJt808Media::sendMediaEvent(MediaEvent &event)
{
    // 这个是空包消息,填写资料上传即可
    QByteArray ba(4000, 0);
    BYTE *send_data = (BYTE *)ba.data();
    int idx = 0;
    // 多媒体数据ID（DWORD）
    long_to_four_char(event.media_id, &send_data[idx]);
    idx += 4;
    // 多媒体类型 BYTE
    send_data[idx++] = event.media_type;
    // 多媒体格式编码 BYTE
    send_data[idx++] = event.media_code;
    // 事件编码 BYTE
    send_data[idx++] = event.event_type;
    // 通道ID BYTE
    send_data[idx++] = event.channel;

    qDebug() << "-->>多媒体事件上报";
    return sendPayload2Jt808Serv(TERMINAL_MEDIA_EVENT, send_data, idx);
}

/*******************************************
函数功能: 查询终端音视频属性
入口参数: int cycle_num,  流水号
        BYTE *payload,   净荷
        WORD lenth       长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procQueryMediaProperty(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--查询终端音视频属性";
    QByteArray ba(100, 0);
    BYTE *send_data = (BYTE *)ba.data();
    int idx = 0;
    // 编码方式 不支持音频编码,这里直接写0
    send_data[idx++] = 0;
    // 采样率 0:8k;1:22.05k;2:44.1k;3:48k
    send_data[idx++] = 3;
    // 采用位数 0:8;1:16;2:32
    send_data[idx++] = 0;
    // 音频帧长度
    send_data[idx++] = 0;
    // 是否至此音频输出 0:不支持；1:支持
    short_to_two_char(0, &send_data[idx]);
    idx += 2;
    // 视频编码方式
    send_data[idx++] = 1;
    // 终端支持的最大音频物理通道
    send_data[idx++] = 0;
    // 终端支持的最大视频入物理通道
    send_data[idx++] = 4;

    qDebug() << "-->>查询终端音视频属性上报";
    return sendPayload2Jt808Serv(TERMINAL_UP_MEDIA_PROPERTY, send_data, idx);
}
/*******************************************
函数功能: 实时音视频请求
入口参数: int cycle_num,  流水号
        BYTE *payload,   净荷
        WORD lenth       长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procRealtimeMediaTrans(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "<<--实时音视频请求";
    // 这个包很简单,直接透传给视频模块
    int result = 0;

    // 如果不是视频,直接返回失败
    int ip_len = payload[0];
    int type = payload[ip_len + 6];
    if (type > 1)
    {
        return sendCommonAnswer(cycle_num, SERVER_RT_MEDIA_TRANS, 1);
    }

    MODULE_MESSAGE msg;
    msg.dst_id = MODULE_CAMERA_MNG;
    msg.dst_type = APP_TYPE_MAIN;
    msg.iCmd = CMD_START_JT808_RT_VIDEO;
    if (lenth < MAX_MESSAGE_BUFF_SIZE)
    {
        memcpy(msg.szBuff, payload, lenth);
    }
    else
    {
        memcpy(msg.szBuff, payload, MAX_MESSAGE_BUFF_SIZE);
    }

    ITcpModule *pTcpModule = dynamic_cast<ITcpModule *>(QueryPlugin("TcpModule"));
    if (pTcpModule)
    {
        pTcpModule->SendMsg(msg, sizeof(msg));
        result = 0;
    }
    else
    {
        result = 1;
    }

    qDebug() << "-->>实时音视频请求应答";
    return sendCommonAnswer(cycle_num, SERVER_RT_MEDIA_TRANS, result);
}

/*******************************************
函数功能: 实时音视频控制
入口参数: int cycle_num,  流水号
        BYTE *payload,   净荷
        WORD lenth       长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procRealtimeMediaControl(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "-->>实时音视频控制";
    // 控制指令 0:关闭; 1:切换码流 2:暂停发送 3:回复发送 4:关闭双向对讲
    MODULE_MESSAGE msg;
    msg.dst_id = MODULE_CAMERA_MNG;
    msg.dst_type = APP_TYPE_MAIN;
    msg.iCmd = CMD_JT808_RT_VIDEO_CONTROL;
    if (lenth < MAX_MESSAGE_BUFF_SIZE)
    {
        memcpy(msg.szBuff, payload, lenth);
    }
    else
    {
        memcpy(msg.szBuff, payload, MAX_MESSAGE_BUFF_SIZE);
    }

    ITcpModule *pTcpModule = dynamic_cast<ITcpModule *>(QueryPlugin("TcpModule"));
    if (pTcpModule)
    {
        pTcpModule->SendMsg(msg, sizeof(msg));
    }

    qDebug() << "-->>实时音视频控制应答";
    return sendCommonAnswer(cycle_num, SERVER_RT_MEDIA_CTRL, 0);
}

/*******************************************
函数功能: 服务端实时音视频传输状态通知
入口参数: int cycle_num,  流水号
        BYTE *payload,   净荷
        WORD lenth       长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procMediaStatusNotify(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "-->>服务端实时音视频传输状态通知";
    // 这里只记录日志,暂时不需要对这个通知做太多处理

    qDebug() << "-->>服务端实时音视频传输状态通知应答";
    return sendCommonAnswer(cycle_num, SERVER_MEDIA_STATUS_NOTIFY, 0);
}

/*******************************************
函数功能: 查询终端媒体文件资源
入口参数: int cycle_num,  流水号
        BYTE *payload,   净荷
        WORD lenth       长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procQueryMediaResource(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "-->>查询终端媒体文件资源";
    FILE_QUERY_INFO query_info;

    int idx = 0;
    BYTE time[6];
    // 通道号
    query_info.channel = payload[idx++];
    // 开始时间
    bcd2time(&payload[idx], time);

    QDate dt = QDate(2000 + time[0], time[1], time[2]);
    QTime tm = QTime(time[3], time[4], time[5]);
    query_info.tmBegin = QDateTime(dt, tm).toTime_t();
    idx += 6;
    // 结束时间
    bcd2time(&payload[idx], time);
    dt = QDate(2000 + time[0], time[1], time[2]);
    tm = QTime(time[3], time[4], time[5]);
    query_info.tmEnd = QDateTime(dt, tm).toTime_t();
    idx += 6;
    // 报警标志
    memcpy(&query_info.alarm_status, &payload[idx], 8);
    idx += 8;
    // 资源类型
    query_info.media_type = payload[idx++];
    // 码流类型
    query_info.stream_code = payload[idx++];
    // 存储类型
    query_info.storage_type = payload[idx++];

    // 这里直接调用接口获取,就不再做消息传递调用了
    VCT_FILE_LIST file_list;
    CFileManager *pFileMng = dynamic_cast<CFileManager *>(QueryPlugin("CFileManager"));
    if (pFileMng)
    {
        pFileMng->queryFileList(query_info, file_list);
    }

    sendFilelistAnswer(cycle_num, file_list);
}

/*******************************************
函数功能: 录像文件列表应答
入口参数: int cycle_num, 流水号
        pFileList*,    文件列表
        file_cnt       文件个数
出口参数:
备    注:
*******************************************/
WORD CJt808Media::sendFilelistAnswer(int cycle_num, VCT_FILE_LIST &file_list)
{
    const int FILE_NODE_SIZE = 28;
    BYTE time[6];
    QByteArray ba(FILE_NODE_SIZE * file_list.size() + 8, 0);
    BYTE *send_data = (BYTE *)ba.data();
    int idx = 0;
    // 流水号
    short_to_two_char(cycle_num, send_data + idx);
    idx += 2;
    // 资源总个数
    long_to_four_char(file_list.size(), send_data + idx);
    idx += 4;
    for (size_t i = 0; i < file_list.size(); i++)
    {
        // 通道号
        send_data[idx++] = file_list[i].channel;
        // 开始时间
        time[0] = file_list[i].tmBegin.date().year() % 100;
        time[1] = file_list[i].tmBegin.date().month();
        time[2] = file_list[i].tmBegin.date().day();

        time[3] = file_list[i].tmBegin.time().hour();
        time[4] = file_list[i].tmBegin.time().minute();
        time[5] = file_list[i].tmBegin.time().second();
        time2bcd(time, &send_data[idx]);
        idx += 6;
        // 结束时间
        time[0] = file_list[i].tmEnd.date().year() % 100;
        time[1] = file_list[i].tmEnd.date().month();
        time[2] = file_list[i].tmEnd.date().day();

        time[3] = file_list[i].tmEnd.time().hour();
        time[4] = file_list[i].tmEnd.time().minute();
        time[5] = file_list[i].tmEnd.time().second();
        time2bcd(time, &send_data[idx]);
        idx += 6;
        // 报警标志
        memcpy(&send_data[idx], &file_list[i].alarms, 8);
        idx += 8;
        // 资源类型
        send_data[idx++] = file_list[i].media_type;
        // 码流类型
        send_data[idx++] = file_list[i].stream_code;
        // 存储类型
        send_data[idx++] = file_list[i].storage_type;
        // 文件大小
        long_to_four_char(file_list[i].file_size, &send_data[idx]);
        idx += 4;
    }

    qDebug() << "-->>查询终端媒体文件资源应答";
    return sendPayload2Jt808Serv(TERMINAL_UP_MEDIA_LIST, send_data, idx);
}

/*******************************************
函数功能: 录像文件回放请求
入口参数: int cycle_num,  流水号
        BYTE *payload,   净荷
        WORD lenth       长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procVideoPlay(int cycle_num, BYTE *payload, WORD lenth)
{
    const int MAX_FILE_PATH_LEN = 260;
    qDebug() << "-->>录像文件回放请求";
    FILE_QUERY_INFO query_info;
    memset(&query_info, 0, sizeof(query_info));
    int idx = 0;
    char szIp[20];
    memset(szIp, 0, sizeof(szIp));
    // IP地址长度
    BYTE ip_len = payload[idx++];
    // IP地址
    strncpy(szIp, (char*)&payload[idx], std::min((int)ip_len, 20));
    idx+=ip_len;
    // tcp端口
    int tcp_port = two_char_to_short(&payload[idx]);
    idx+=2;
    // udp端口
    int udp_port = two_char_to_short(&payload[idx]);
    idx+=2;
    // 通道
    query_info.channel = payload[idx++];
    // 媒体类型
    query_info.media_type = payload[idx++];
    // 码流类型
    query_info.stream_code = payload[idx++];
    // 存储类型
    query_info.storage_type = payload[idx++];

    // 回放方式
    BYTE play_mode = payload[idx++];
    // 快进快退倍速
    BYTE play_speed = payload[idx++];
//    // 快进快退倍速
//    BYTE play_speed2 = payload[idx++];

    BYTE time[6];
    // 开始时间
    bcd2time(&payload[idx], time);

    QDate dt = QDate(2000 + time[0], time[1], time[2]);
    QTime tm = QTime(time[3], time[4], time[5]);
    query_info.tmBegin = QDateTime(dt, tm).toTime_t();
    idx += 6;
    // 结束时间
    bcd2time(&payload[idx], time);
    dt = QDate(2000 + time[0], time[1], time[2]);
    tm = QTime(time[3], time[4], time[5]);
    query_info.tmEnd = QDateTime(dt, tm).toTime_t();
    idx += 6;

    qDebug() << "-->>录像文件回放请求应答";
    // 这里直接调用接口获取,就不再做消息传递调用了
    VCT_FILE_LIST file_list;
    CFileManager *pFileMng = dynamic_cast<CFileManager *>(QueryPlugin("CFileManager"));
    if (pFileMng)
    {
        pFileMng->queryFileList(query_info, file_list);
        // 只播放第一个视频
        if (file_list.size() >0)
        {
            CCamFileNode &node = file_list[0];
            // 发送消息播放视频
            MODULE_MESSAGE msg;
            int msg_idx = 0;
            msg.dst_id = MODULE_CAMERA_MNG;
            msg.dst_type = APP_TYPE_MAIN;
            msg.iCmd = CMD_START_JT808_HIS_VIDEO;


            // ip地址这里取总长度20
            strncpy((char*)&msg.szBuff[msg_idx], szIp, 20);
            msg_idx+=20;
            // tcp 端口
            short_to_two_char(tcp_port, &msg.szBuff[msg_idx]);
            msg_idx += 2;
            // udp 端口
            short_to_two_char(udp_port, &msg.szBuff[msg_idx]);
            msg_idx += 2;
            // 通道号
            msg.szBuff[msg_idx++] = node.channel;
            // 文件名,长度取 getFilePathName()
            QString strPathName = pFileMng->getPathName(node.fileName);
            strncpy((char*)&msg.szBuff[msg_idx], strPathName.toStdString().c_str(),  MAX_FILE_PATH_LEN);
            msg_idx += MAX_FILE_PATH_LEN;
            // 播放倍速
            msg.szBuff[msg_idx++] = play_speed;

            ITcpModule *pTcpModule = dynamic_cast<ITcpModule *>(QueryPlugin("TcpModule"));
            if (pTcpModule)
            {
                pTcpModule->SendMsg(msg, sizeof(msg));
            }

            // 返回操作成功
            sendCommonAnswer(cycle_num, SERVER_VIDEO_FILE_PLAY, 0);

        }
    }

    sendCommonAnswer(cycle_num, SERVER_VIDEO_FILE_PLAY, 1);

    return idx;
}

/*******************************************
函数功能: 录像文件回放控制
入口参数: int cycle_num,  流水号
        BYTE *payload,   净荷
        WORD lenth       长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procVideoControl(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "-->>录像文件回放控制";
    // 这里只记录日志,暂时不需要对这个通知做太多处理

    qDebug() << "-->>录像文件回放控制应答";
}

/*******************************************
函数功能: 文件上传请求
入口参数: int cycle_num,  流水号
        BYTE *payload,   净荷
        WORD lenth       长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procFileUpload(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "-->>文件上传请求";
    // 这里只记录日志,暂时不需要对这个通知做太多处理

    qDebug() << "-->>文件上传请求应答";
}

/*******************************************
函数功能: 文件上传控制
入口参数: int cycle_num,  流水号
        BYTE *payload,   净荷
        WORD lenth       长度
出口参数:
备    注:
*******************************************/
WORD CJt808Media::procFileUploadControl(int cycle_num, BYTE *payload, WORD lenth)
{
    qDebug() << "-->>文件上传控制通知";
    // 这里只记录日志,暂时不需要对这个通知做太多处理

    qDebug() << "-->>文件上传控制应答";
}
