#ifndef __JT_T808_H_
#define __JT_T808_H_
#include "jt808_common.h"
#include "message.h"
#include <string.h>

/*-------------------------T808协议消息ID--------------------------*/
#define TERMINAL_NORMAL_ANSWER 0x0001       // 通用应答
#define TERMINAL_HEARTBEAT 0x0002           // 心跳
#define TERMINAL_DEREGIST 0x0003            // 终端注消
#define TERMINAL_SERV_TIME_ASK 0x0004       // 查询服务器时间
#define TERMINAL_SEP_PACKET_ASK 0x0005      // 终端补发分包请求
#define TERMINAL_REGIST 0x0100              // 终端注册
#define TERMINAL_AUTHENTICATION 0x0102      // 终端鉴权
#define TERMINAL_ANSWER_SYS_CFG 0x0104      // 参数查询应答
#define TERMINAL_PROPERTY_ANSWER 0x0107     // 响应属性应答
#define TERMINAL_UPDATE_ANSWER 0x0108       // 终端升级结果应答
#define TERMINAL_UP_GPS_DATA 0x0200         // 位置信息上报
#define TERMINAL_ANWSER_GPS_DATA 0x0201     // 位置信息应答
#define TERMINAL_EVENT_REPORT 0x0301        // 事件报告
#define TERMINAL_RETURN_ANSWER 0x0302       // 回答提问
#define TERMINAL_RETURN_ODER 0x0303         // 选择或取消点播
#define TERMINAL_VEHICLE_CTRL 0x0500        // 车辆控制
#define TERMINAL_AERA_INFO_ANSWER 0x0608    // 线路或区域信息应答
#define TERMINAL_UP_RECODE 0x0700           // 行驶记录仪数据上传
#define TERMINAL_UP_FREIGHT_NOTE 0x0701     // 电子运单上报
#define TERMINAL_UP_DRIVER_INFO 0x0702      // 驾驶员信息
#define TERMINAL_UP_MULTI_GPS_DATA 0x0704   // 定位数据批量上传
#define TERMINAL_UP_CAN_DATA 0x0705         // CAN总线数据上传
#define TERMINAL_MEDIA_EVENT 0x0800         // 多媒体事件上传
#define TERMINAL_UP_MEDIA 0x0801            // 多媒体上传
#define TERMINAL_MEDIA_CHECK_RETURN 0x0802  // 媒体检索返回
#define TERMINAL_TAKE_PICTURE_ANSWER 0x0805 // 拍照应答
#define TERMINAL_TRANSMISSION 0x0900        // 上行透传
#define TERMINAL_UP_ZIP 0x0901              // 数据压缩上报
#define TERMINAL_RSA 0x0A00                 // RSA

// JT1078
#define TERMINAL_UP_MEDIA_PROPERTY 0x1003  // 终端上报音视频属性
#define TERMINAL_UP_GUEST_NUMBER 0x1005    // 终端上报乘客数量
#define TERMINAL_UP_MEDIA_LIST 0x1205      // 终端上报媒体资源列表
#define TERMINAL_UP_UPLOAD_FINISHED 0x1206 // 文件上传完成通知

// =======
#define SERVER_NORMAL_ANSWER 0x8001      // 通用应答
#define SERVER_SEP_PACKET_ASK 0x8003     // 服务器补发分包请求
#define SERVER_SERV_TIME_ANSWER 0x8004   // 服务器应答时间
#define SERVER_REGIST_ANSWER 0x8100      // 终端注册应答
#define SERVER_SET_TERMINAL_CFG 0x8103   // 设置终端参数
#define SERVER_READ_TERMINAL_CFG 0x8104  // 读取终端参数
#define SERVER_CTRL_TERMINAL 0x8105      // 终端控制
#define SERVER_READ_SOME_CFG 0x8106      // 读取终端指定参数
#define SERVER_PROPERTY_ASK 0x8107       // 查询属性
#define SERVER_UPDATE_ASK 0x8108         // 下发升级包
#define SERVER_READ_GPS_DATA 0x8201      // 查询终端位置信息
#define SERVER_TEMPORARY_LOC_CTRL 0x8202 // 临时位置跟踪控制
#define SERVER_CONFIRM_ALARM 0x8203      // 人工确认报警消息
#define SERVER_CONNECTION_CHECK 0x8204   // 链路检查
#define SERVER_SEND_TEXT 0x8300          // 文本信息下发
#define SERVER_EVENT_SET 0x8301          // 事件下发
#define SERVER_SEND_ASK 0x8302           // 提问
#define SERVER_SEND_ODER 0x8303          // 点播
#define SERVER_SEND_MSG 0x8304           // 信息服务
#define SERVER_CALL_BACK 0x8400          // 回拨
#define SERVER_SET_PHONE_BOOK 0x8401     // 设置电话本
#define SERVER_VEHICLE_CTRL 0x8500       // 车辆控制
#define SERVER_SET_AREA_ROUND 0x8600     // 设置圆型区域
#define SERVER_DEL_AREA_ROUND 0x8601     // 删除圆形区域
#define SERVER_SET_AREA_RECT 0x8602      // 设置矩形区域
#define SERVER_DEL_AREA_RECT 0x8603      // 删除矩形区域
#define SERVER_SET_AREA_POLYGON 0x8604   // 设置多边形区域
#define SERVER_DEL_AREA_POLYGON 0x8605   // 删除多边形区域
#define SERVER_SET_AREA_ROUTE 0x8606     // 设置路线
#define SERVER_DEL_AREA_ROUTE 0x8607     // 删除线路
#define SERVER_QUERY_AERA_INFO 0x8608    // 查询线路或区域信息
#define SERVER_READ_RECODE 0x8700        // 读取行驶记录
#define SERVER_SET_RECODE 0x8701         // 记录参数下传设置
#define SERVER_REQUEST_IDCARD 0x8702     // 上报驾驶员身份信息请求
#define SERVER_MEDIA_RETURN 0x8800       // 多媒体上传应答
#define SERVER_TAKE_PICTURE 0x8801       // 拍照
#define SERVER_MEDIA_CHECK 0x8802        // 存储多媒体数据检索
#define SERVER_READ_MEDIA 0x8803         // 媒体数据上传
#define SERVER_RECORD_SOUND 0x8804       // 开始录音
#define SERVER_UPLOAD_MEDIADATA 0x8805   // 单条多媒体数据检索上传
#define SERVER_TRANSMISSION 0x8900       // 下行透传
#define SERVER_RSA 0x8A00                // RSA 密钥

// 自定义命令字
#define SERVER_SET_MACROPHONE_CONFIG 0xF001 // 手咪配置下发

// JT1078
#define SERVER_QUERY_MEDIA_PROPERTY 0x9003 // 查询终端音视频属性
#define SERVER_RT_MEDIA_TRANS 0x9101       // 实时音视频请求
#define SERVER_RT_MEDIA_CTRL 0x9102        // 实时音视频控制
#define SERVER_MEDIA_STATUS_NOTIFY 0x9105  // 服务端实时音视频传输状态通知
#define SERVER_QUERY_MEIDA_RESOURCE 0x9205 // 查询终端媒体文件资源
#define SERVER_VIDEO_FILE_PLAY 0x9201      // 录像文件回放请求
#define SERVER_VIDEO_FILE_CTRL 0x9202      // 录像文件回放控制
#define SERVER_FILE_UPLOAD 0x9206          // 文件上传请求
#define SERVER_FILE_UPLOAD_CTRL 0x9207     // 文件上传控制
#define SERVER_PTZ_ROTATAL 0x9301          // 云台旋转
#define SERVER_PTZ_FOCUS 0x9302            // 焦距调整
#define SERVER_PTZ_APERTURE 0x9303         // 光圈调整
#define SERVER_PTZ_WIPER 0x9304            // 雨刷控制
#define SERVER_PTZ_INFRARED_LIGHT 0x9305   // 红外补光
#define SERVER_PTZ_ZOOM 0x9306             // 变倍控制

//#define SERV_VIDEO_PLAY

/*-------------------------T808协议参数ID--------------------------*/
#define SET_HEARTBEAT_TIME 0x0001             // 心跳时间间隔 秒
#define SET_TCP_WAIT_TIME 0x0002              // TCP超时时间 秒
#define SET_TCP_RETRY_TIMES 0x0003            // TCP重传次数
#define SET_UDP_WAIT_TIME 0x0004              // UDP超时时间 秒
#define SET_UDP_RETRY_TIMES 0x0005            // UDP重传次数
#define SET_SMS_WAIT_TIME 0x0006              // 短消息应答超时 秒
#define SET_SMS_RETRY_TIMES 0x0007            // 短消息重传次数
#define SET_MAIN_SERVER_DIAL_APN 0x0010       // 主服务器APN
#define SET_MAIN_SERVER_DIAL_USER 0x0011      // 用户名
#define SET_MAIN_SERVER_DIAL_PWD 0x0012       // 密码
#define SET_MAIN_SERVER_ADDR 0x0013           // 主服务器地址
#define SET_BACK_SERVER_DIAL_APN 0x0014       // 备份服务器APN
#define SET_BACK_SERVER_DIAL_USER 0x0015      // 用户名
#define SET_BACK_SERVER_DIAL_PWD 0x0016       // 密码
#define SET_BACK_SERVER_ADDR 0x0017           // 备份服务器地址
#define SET_MAIN_SERVER_TCP_PORT 0x0018       // 服务器TCP端口
#define SET_MAIN_SERVER_UDP_PORT 0x0019       // 服务器UDP端口
#define SET_IC_SERVER_ADDR 0x001A             // IC卡认证服务器主地址
#define SET_IC_SERVER_TCP_PORT 0x001B         // IC卡认证服务器TCP端口
#define SET_IC_SERVER_UDP_PORT 0x001C         // IC卡认证服务器UDP端口
#define SET_IC_SERVER_ADDR_BACK 0x001D        // IC卡认证服务器备用地址
#define SET_UP_GPSDATA_TACTICS 0x0020         // 数据上报策略 0定时 1定距 2混合
#define SET_UP_GPSDATA_PLAN 0x0021            // 0:ACC 1 驾驶员登录状态
#define SET_UP_GPSDATA_TIME_NODRIV 0x0022     // 无驾驶员信息时的上报时间间隔 秒
#define SET_UP_SLAVE_SERV_APN 0x0023          // 从服务器APN
#define SET_UP_SERV_USERNAME 0x0024           // 从服务器无线通讯拨号用户名
#define SET_UP_SERV_PASSWORD 0x0025           // 从服务器无线通讯拨号密码
#define SET_UP_SERV_BAK_IP 0x0026             // 从服务器备用地址 ip或域名(端口用:分割，多个服务器用;分割)
#define SET_UP_REPORT_INTERVAL_SLEEP 0x0027   // 休眠时的上报时间间隔
#define SET_UP_GPSDATA_TIME_ALARM 0x0028      // 报警时的上报间隔
#define SET_UP_GPSDATA_TIME_DEFAULT 0x0029    // 正常上报时间间隔
#define SET_UP_GPSDATA_LENTH_DEFAULT 0x002C   // 正常上报距离间隔
#define SET_UP_GPSDATA_LENTH_NODRIV 0x002D    // 无驾驶员信息时的上报距离间隔 米
#define SET_UP_GPSDATA_LENTH_SLEEP 0x002E     // 休眠时的上报时间间隔
#define SET_UP_GPSDATA_LENTH_ALARM 0x002F     // 报警时的上报间隔
#define SET_UP_GPSDATA_ANGLE 0x0030           // 拐点补传
#define SET_UP_ILLEGAL_MOVE 0x0031            // 非法位移阀值(米)
#define SET_UP_ILLEGAL_TIME 0x0032            // 违规行驶时间段范围精准到分，BYTE1 开始小时 BYTE2开始分钟数 BYTE3 结束小时 byte4 结束分钟
#define SET_SERVICE_TEL_NUM 0x0040            // 服务平台号码
#define SET_RESET_TEL_NUM 0x0041              // 复位号码
#define SET_SET_DEFAULT_TEL_NUM 0x0042        // 恢复出厂号码
#define SET_SERVICE_SMS_NUM 0x0043            // 服务平台号短息号码
#define SET_SERVICE_ALARM_NUM 0x0044          // 服务平台报警号短息号码
#define SET_TEL_ANSWER_TACTICS 0x0045         // 0自动接听 1 ACCON时自动接听
#define SET_MAX_TEL_TIME_ONCE 0x0046          // 一次通话的最长时间 0为不允许 0xFFFFFFFF为无限制
#define SET_MAX_TEL_TIME_MONTH 0x0047         // 一月最长通话时间      同上
#define SET_LISTEN_TEL_NUM 0x0048             // 监听号码
#define SET_PREROG_SMS_NUM 0x0049             // 特权短信号码
#define SET_ALARM_MASK 0x0050                 // 报警屏蔽字，和位置信息中的报警位对应，为1的发送相应报警
#define SET_ALARM_SMS_MASK 0x0051             // 短消息报警屏蔽字，和位置信息中的报警位对应，为1的发送相应报警
#define SET_CAM_MASK 0x0052                   // 拍照屏蔽字，同上
#define SET_CAM_SAVE_MASK 0x0053              // 拍照存储屏蔽字，为1存储同上
#define SET_CRUCIAL_ALARM_MASK 0x0054         // 关键报警屏蔽字为1
#define SET_OVER_SPEED 0x0055                 // 超速值
#define SET_OVER_SPEED_TIME 0x0056            // 超速持续时间
#define SET_OVER_TIME_ONCE 0x0057             // 单次连续驾驶超时 秒
#define SET_OVER_TIME_DAY 0x0058              // 一天连续驾驶超时
#define SET_MIN_REST_TIME 0x0059              // 最小休息时间
#define SET_MAX_STOP_TIME 0x005A              // 最长停车时间
#define SET_OVER_SPEED_NOTICE 0x005B          // 超速报警预警差值
#define SET_OVER_TIME_NOTICE 0x005C           // 超速报警预警差值
#define SET_COLLISION_ALARM 0x005D            // 碰撞报警参数设置
#define SET_ROLLOVER_ALARM 0x005E             // 侧翻报警参数设置
#define SET_FIXTIME_PHOTOGRAPH_CONTROL 0x0064 // 定时拍照控制
#define SET_FIXDIS_PHOTOGRAPH_CONTROL 0x0065  // 定距拍照控制
#define SET_MEDIA_ALITY 0x0070                // 媒体质量 1-10 1最好
#define SET_BRIGHTNESS 0x0071                 // 亮度0-255
#define SET_CONTRAST 0x0072                   // 对比度 同上
#define SET_SATURATION 0x0073                 // 饱和度 同上
#define SET_CHROMA 0x0074                     // 色度
#define SET_ODOMETER 0x0080                   // 里程 0.1KM
#define SET_PROVINCE_ID 0x0081                // 车辆所在省ID
#define SET_CITY_ID 0x0082                    // 车辆所在市ID
#define SET_VEHICLE_ID 0x0083                 // 车牌号
#define SET_VEHICLE_COLOR 0x0084              // 车辆颜色
#define SET_GNSS_MODE_TYPE 0x0090             // GNSS定位模式
#define SET_GNSS_BITRATE 0x0091               // GNSS波特率设置
#define SET_GNSS_MESSAGE_FREQUENCY 0x0092     // GNSS定位数据输出频率
#define SET_GNSS_MESSAGE_COLLECTION 0x0093    // GNSS定位数据采集频率
#define SET_GNSS_MESSAGE_SEND_TYPE 0x0094     // GNSS定位数据上传频率
#define SET_GNSS_MESSAGE_SEND_SET 0x0095      // GNSS定位数据上传设置
#define SET_CAN1_COLLECTION_TIME 0x0100       // CAN通道1采集时间间隔
#define SET_CAN1_SEND_TIME 0x0101             // CAN通道1发送时间间隔
#define SET_CAN2_COLLECTION_TIME 0x0102       // CAN通道2采集时间间隔
#define SET_CAN2_SEND_TIME 0x0103             // CAN通道2发送时间间隔
#define SET_CAN_ID_COLLECTION 0x0110          // CAN总线ID0单独采集设置
#define SET_CAN_ID_COLLECTION1 0x0111         // CAN总线ID1单独采集设置
#define SET_CAN_ID_COLLECTION2 0x0112         // CAN总线ID2单独采集设置
#define SET_CAN_ID_COLLECTION3 0x0113         // CAN总线ID3单独采集设置

#pragma pack(push, 1)
// 消息体属性
union MSG_ATTR
{
    struct Bit
    {
        uint16_t msglen : 10; // 消息体长度
        uint16_t encrypt : 3; // 数据加密方式, 当此三位都为0, 表示消息体不加密;
                              //   当第10位为1, 表示消息体经过RSA算法加密
        uint16_t package : 1; // 分包标记
        uint16_t version : 1; // 保留
        uint16_t retain : 1;  // 保留
    } bit;
    uint16_t value;
};

/* 状态位 */
typedef union
{
    DWORD value;
    struct
    {
        BYTE acc_on : 1;       // 0 acc状态      0关     1开
        BYTE gps_fix : 1;      // 1 gps是否定位  0不定位 1定位
        BYTE gps_ns : 1;       // 2 0北纬 1南纬
        BYTE gps_ew : 1;       // 3 0东经 1西经
        BYTE op_status : 1;    // 4 运营状态     0运营   1停运
        BYTE gps_enc : 1;      // 5 经纬度加密   0不加密 1加密
        BYTE recv6to7 : 2;     // 6--7保留
        BYTE car_state : 2;    // 8:9    00:空载  01:半截 10:Ref  11: 满截
        BYTE oilway : 1;       // 10 车辆油路    0正常   1断开
        BYTE power : 1;        // 11 车辆电路    0正常   1断开
        BYTE door_lock : 1;    // 12 车门        0解锁   1加锁
        BYTE door_stata1 : 1;  // 13 门1状态
        BYTE door_stata2 : 1;  // 14 门2状态
        BYTE door_stata3 : 1;  // 15 门3状态
        BYTE door_stata4 : 1;  // 16 门4状态
        BYTE door_stata5 : 1;  // 17 门5状态
        BYTE gps_used : 1;     // 18 使用GPS定位
        BYTE beidou_used : 1;  // 19 使用北斗定位
        BYTE glonass_used : 1; // 20 使用glonass卫星定位
        BYTE galileo_used : 1; // 21 使用伽利略定位
        WORD recv22to31 : 10;  // 22--31 保留
    } reg;
} UNIT_STATUS;

/* 报警状态 */
typedef union
{
    DWORD value;
    struct
    {
        BYTE SOS : 1;                // 紧急报警_触动报警开关后触发
        BYTE speed : 1;              // 超速报警
        BYTE overtime : 1;           // 疲劳驾驶
        BYTE danger : 1;             // 危险预警
        BYTE gnss : 1;               // GNSS模块发生故障
        BYTE gnss_anten_cut : 1;     // GNSS天线未接或被剪断
        BYTE gnss_anten_short : 1;   // GNSS天线短路
        BYTE pwr_low : 1;            // 终端主电源欠压
        BYTE pwr_lose : 1;           // 终端主电源掉电
        BYTE lcd_error : 1;          // 终端LCD或显示器故障
        BYTE tts_error : 1;          // TTS模块故障
        BYTE camera_error : 1;       // 摄像头故障
        BYTE id_error : 1;           // 道路运输证IC卡模块故障
        BYTE speed_warring : 1;      // 超速预警
        BYTE overtime_warring : 1;   // 疲劳驾驶预警
        BYTE recv1 : 1;              // 保留1
        BYTE recv2 : 1;              // 保留2
        BYTE recv3 : 1;              // 保留3
        BYTE cnt_drive_overtime : 1; // 当天累计驾驶超时
        BYTE stop_overtime : 1;      // 超时停车
        BYTE area : 1;               // 进出区域
        BYTE line : 1;               // 进出路线
        BYTE line_time : 1;          // 路段行驶时间不足或过长
        BYTE line_deviate : 1;       // 路线偏离报警
        BYTE vss : 1;                // 车辆VSS故障
        BYTE fuel : 1;               // 车辆油量异常
        BYTE theft : 1;              // 车辆被盗通过车辆防盗器
        BYTE acc_noallow : 1;        // 车辆非法点火
        BYTE move_noallow : 1;       // 车辆非法位移
        BYTE collision : 1;          // 碰撞预警
        BYTE Rollover : 1;           // 侧翻预警
        BYTE door_noallow : 1;       // 非法开门报警
    } reg;
} ALARM_STATUS;

#pragma pack(pop)

struct JT808MSG_INDEX
{
    JT808MSG_INDEX()
    {
    }
    JT808MSG_INDEX(WORD msg_id, MODULE_ID module_id, MODULE_COMMAND_ID module_msg)
        : m_msgId(msg_id),
          m_moduleId(module_id),
          m_moduleMsg(module_msg)
    {
    }
    // jt808命令字
    WORD m_msgId;
    // 目标模块
    MODULE_ID m_moduleId;
    // 目标命令字
    MODULE_COMMAND_ID m_moduleMsg;
};

#endif
