#ifndef DOWNLOADFILE_H
#define DOWNLOADFILE_H

#include <QObject>
#include <QString>
#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QNetworkReply>
#include <QUrl>
#include <QFile>
#include <QList>
#include <QByteArray>
#include "common.h"

class FileDownloader : public QObject
{
    Q_OBJECT

signals:
    void notifyDownloadFinished(QString, bool);
    void downloadProgress(qint64 bytesSent, qint64 bytesTotal);
    void error(QString error);

public:
    FileDownloader();
    FileDownloader(QString downloadPath, QString storePath, QString installPath = "", bool start = false);
    ~FileDownloader();

    void setDownloadPara(QString downloadPath, QString storePath, QString installPath= "");
    void start();
    void stop();

private slots:
    void downloadFinished();
    void mdownloadProgress(qint64 bytesReceived, qint64 bytesTotal);
    void networkError(QNetworkReply::NetworkError error);
    void onReadyRead();
private:
    QNetworkAccessManager* m_manager;
    QNetworkRequest* m_networkRequest;
    QNetworkReply* m_reply;
    QList<QByteArray> m_data;
    QFile* m_file;
    QString m_downloadPath;
    QString m_storePath;
    QString m_installPath;
    qint64 m_bytesReceived;
    qint64 m_bytestotal;

    BYTE * m_pFileBuff;
};

#endif // DOWNLOADFILE_H
