#include "CCustomButton.h"
#include <QPainter>
#include <QDebug>
#include <QBitmap>

CCustomButton::CCustomButton(QWidget *parent)
    : QToolButton(parent),
    m_iGroupIndex(0)
{
    m_pixUnselect = QPixmap(":/images/start.png").scaled(80, 80);
    m_pixEnter = QPixmap(":/images/start.png").scaled(80, 80);
    m_pixSelected = QPixmap(":/images/stop.png").scaled(80, 80);
    m_pixLeave = QPixmap(":/images/stop.png").scaled(80, 80);
    this->setCheckable(true);

    connect(this, SIGNAL(clicked(bool)), this, SLOT(ontoggled(bool)));
}

void CCustomButton::setPixmap(QPixmap &pixnormal, QPixmap &pixenter, QPixmap &pixchecked, QPixmap &pixleave)
{
    QSize size(80, 80);
    m_pixUnselect = pixnormal.scaled(size).copy(0, 0, 80, 80);
    m_pixEnter = pixenter.scaled(size).copy(0, 0, 80, 80);
    m_pixSelected = pixchecked.scaled(size).copy(0, 0, 80, 80);
    m_pixLeave = pixleave.scaled(size).copy(0, 0, 80, 80);
    setMask(QBitmap(m_pixUnselect.mask()));
}

void CCustomButton::enterEvent(QEvent *)
{
    m_enter = true;
}

void CCustomButton::leaveEvent(QEvent *)
{
    m_enter = false;
}

void CCustomButton::paintEvent(QPaintEvent *)
{
    QPainter painter(this);

    if (this->isChecked())
    {
        if (m_enter)
        {
            painter.drawPixmap(rect(), m_pixLeave);
        }
        else
        {
            painter.drawPixmap(rect(), m_pixSelected);
        }
    }
    else
    {
        if (m_enter)
        {
            painter.drawPixmap(rect(), m_pixEnter);
        }
        else
        {
            painter.drawPixmap(rect(), m_pixUnselect);
        }
    }
}

void CCustomButton::ontoggled(bool checked)
{
    (void)checked;
    bool bChecked = this->isChecked();
    if (bChecked)
    {
        emit notifyItemState(m_iGroupIndex, true);
        QAbstractButton::toggled(false);
    }
    else
    {
        emit notifyItemState(m_iGroupIndex, false);
        QAbstractButton::toggled(true);
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CIconButton::ontoggled(bool checked)
{
    emit notifyBtnStateChanged(m_iIconIndex, !checked);
}

//设置index
void CIconButton::setIndex(int index)
{
    m_iIconIndex = index;
    QString strIconEn = QString(":/icons/btn%1_en.png").arg(index+1);
    QString strIconDis = QString(":/icons/btn%1_dis.png").arg(index+1);
    m_pixUnselect = QPixmap(strIconEn).scaled(80, 80);
    m_pixEnter = QPixmap(strIconEn).scaled(80, 80);
    m_pixSelected = QPixmap(strIconDis).scaled(80, 80);
    m_pixLeave = QPixmap(strIconDis).scaled(80, 80);
}
