﻿#ifndef CustomButton_H
#define CustomButton_H
#include <QWidget>
#include <QPaintEvent>
#include <QEvent>
#include <QToolButton>
#include <qpropertyanimation.h>
#include <QDebug>
#include <vector>

class CCustomButton : public QToolButton
{
    Q_OBJECT
public:
    CCustomButton(QWidget *parent = nullptr);
    void setPixmap(QPixmap &pixnormal, QPixmap &pixenter, QPixmap &pixchecked, QPixmap &pixleave);
    void setGroupIndex(int idx) { m_iGroupIndex = idx; }

protected:
    virtual void enterEvent(QEvent *);
    virtual void leaveEvent(QEvent *);
    virtual void paintEvent(QPaintEvent *);
signals:
    void notifyItemState(int, bool);

public slots:
    virtual void ontoggled(bool checked);

protected:
    QPixmap m_pixUnselect;
    QPixmap m_pixEnter;
    QPixmap m_pixSelected;
    QPixmap m_pixLeave;

    bool m_enter;
    bool m_leave;

    int m_iGroupIndex;
};

class CIconButton : public CCustomButton
{
    Q_OBJECT
public:
    CIconButton(QWidget *parent = nullptr)
        : CCustomButton(parent){};

    //更新状态
    void updateState(bool bUpdate) { m_bUpdate = bUpdate; }
    //是否已经刷新
    bool isUpdated() { return m_bUpdate; }

    //设置index
    void setIndex(int index);

public slots:
    virtual void ontoggled(bool checked);

signals:
    void notifyBtnStateChanged(int, bool);

protected:
    //这里增加一个标记位，在没有刷新的情况下，将按钮隐藏
    bool m_bUpdate;

    int m_iIconIndex;
};

#endif // CustomButton_H
