#ifndef CDIALOGINITIALIZE_H
#define CDIALOGINITIALIZE_H

#include <QDialog>
#include <QTimer>

namespace Ui {
class CDlgServSetting;
}

class CWebSocketClient;
class CDeviceManager;
// 服务器IP设置窗体
class CDlgServSetting : public QDialog
{
    Q_OBJECT

public:
    explicit CDlgServSetting(QString strHost, QWidget *parent = 0);
    ~CDlgServSetting();

    // 获取服务器HOST地址，这个地址不含设备ID，主要用于保存
    QString getServHost();

    // 检查连接是否正常
    bool checkConnect();

    // 获取服务器地址，这个地址是加了设备ID的地址，直接用于连接服务端
    QString getServAddr();

    // 确定处理消息
    virtual void done(int code) override;

public slots:
    // 连接成功绰力
    void onServConnected();

private slots:
    // 检查按钮点击操作
    void on_btn_check_clicked();

    // 确认按钮点击操作
    void on_btn_ok_clicked();

    // 超时处理
    void onConnTimeout();

private:
    Ui::CDlgServSetting *ui;

    // 服务地址是否政策
    bool m_bServAddrOk;
    // 连接后是否关闭窗体
    bool m_bClosedOnConnected;

    // 依赖模块
    CWebSocketClient *m_pWebSock;
	CDeviceManager *m_devMsg;
};

#endif // CDIALOGINITIALIZE_H
