#ifndef DLGMAINSETTING_H
#define DLGMAINSETTING_H

#include <QDialog>
#include <QListWidget>
#include <QComboBox>
#include <QButtonGroup>
#include "config/CConfigManager.h"

class CDeviceManager;

namespace Ui
{
    class DlgMainSetting;
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
/////////////////////////////// 这个窗体暂时废弃  ///////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// 设置窗体
class DlgMainSetting : public QDialog
{
    Q_OBJECT

public:
    explicit DlgMainSetting(CConfigManager &cfg_data, QWidget *parent = 0);
    ~DlgMainSetting();

private slots:

    // 设置视频源为不可用状态
    void setCombItemDisable(QComboBox *pComb, QString str);

    // 设置视频源为可用状态
    void setCombItemEnable(QComboBox *pComb, QString str);

    // 视频源1选择变更
    void on_combCam1_currentIndexChanged(int index);

    // 视频源2选择变更
    void on_combCam2_currentIndexChanged(int index);

    // 视频源3选择变更
    void on_combCam3_currentIndexChanged(int index);

    // 视频源4选择变更
    void on_combCam4_currentIndexChanged(int index);

    void on_btnApply_clicked();

    void onSetCam1Dec(int, bool);
    void onSetCam2Dec(int, bool);
    void onSetCam3Dec(int, bool);
    void onSetCam4Dec(int, bool);

signals:
    void notifyClose();

private:
    Ui::DlgMainSetting *ui;

    CDeviceManager *m_pDevMng;

    CConfigManager *m_pMainCfgData;

    bool m_bNeedUpdate;
    bool m_bInitialized;

    // 当前选择视频源
    QString m_curVideoSrc[MAX_CAMERA_COUNT];
    int m_iDecType[MAX_CAMERA_COUNT];
};

#endif // DLGMAINSETTING_H
