#ifndef FORMLOGIN_H
#define FORMLOGIN_H

#include <QDialog>
#include <QTimer>

class CDeviceManager;
class CWebSocketClient;
class CDatebase;
class CConfigManager;
/*
namespace Ui
{
    class FormLogin;
}
*/
using namespace std;


// 登录界面
class FormLogin : public QDialog
{
    Q_OBJECT
public:
    explicit FormLogin(QWidget *parent = 0);
    ~FormLogin();

   

private slots:
    // 登陆操作
    void on_btnLogin_clicked();

    // 退出程序
    void on_btnQuit_clicked();

    // 处理登陆结果
    void onLogined(bool bSuccess);

    // 检查登录
    void onCheckLogin();

    // 保存配置文件
    void saveLoginCfg();

    // 保存配置文件
    bool restoreFromDB(CDatebase *pDatebase);

    // 创建配置文件
    bool createDatebase();

    // 设置自动登陆
    void on_autoLogin_clicked(bool checked);

    // 登陆超时处理
    void onLoginTimeout();

    // 配置服务器按钮点击操作
    void on_pushButton_clicked();

    // 连接成功处理
    void onConnected();

protected:
    // 更新配置文件
    void updateCfgFile(QString strPath, bool bRemUser, bool bAutoLogin, QString strUser, QString strPwd);

    // 导入配置文件
    bool loadCfgFile(QString strPath, bool &bRemUser, bool &bAutoLogin, QString &strUser, QString &strPwd);

    // 获取服务器地址（带设备ID）
    QString genConnectAddr(QString strHost);

private:

    // 依赖模块
    CDeviceManager *m_pDevMng;
    CWebSocketClient *m_pWebSock;
    CConfigManager *m_pConfigMng;
	QString strUser, strPwd;

    // 是否已经登录
    bool m_bLogined;

    // 定时器
    QTimer m_TimerMonitor;

    // 本地用户数据库
    CDatebase *m_pDbLogin;
};

#endif // FORMLOGIN_H
