﻿#include "SplashScreen.h"
#include <QProgressBar>

SplashScreen::SplashScreen(QPixmap pixmap, QWidget *parent):
    QSplashScreen(parent, pixmap),
    ui(new Ui::SplashScreen),
    bar(nullptr)
{

    ui->setupUi(this);
    bar = new QProgressBar(this);
    //设置进度条的位置
    bar->setGeometry(0,pixmap.height()-50,pixmap.width(),10);
    bar->setAlignment(Qt::AlignCenter);
    resize(pixmap.size());

#ifdef QT_NO_DEBUG
    setWindowFlags(windowFlags() | Qt::WindowStaysOnTopHint);
#endif

}

SplashScreen::~SplashScreen()
{
    delete ui;
}

// 设置进度区域
void SplashScreen::setRange(int min, int max)
{
    bar->setRange(min, max);
}

// 更新进度
void SplashScreen::updateProgress(int num)
{
    bar->setValue(num);
}

// 显示消息
void SplashScreen::showProgressMessage(const QString &msg)
{
    showMessage(msg,Qt::AlignBottom|Qt::AlignHCenter, Qt::white);
}
