#ifndef CFORMCAMVIEWER_H
#define CFORMCAMVIEWER_H
#include  <glib.h>
#include  <gst/gst.h>
#include  <gst/video/videooverlay.h>

#include <QLabel>
#include <QSlider>
#include <QPushButton>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QTimer>

namespace Ui {
class CFormCamViewer;
}

//
class CFormCamViewer : public QLabel
{
    Q_OBJECT

public:
    explicit CFormCamViewer(QWidget *parent = 0);
    ~CFormCamViewer();
    void setPipeLine(GstElement *p);
    void releasePipeLine();

    WId getVideoWId() const ;

protected:
    virtual void enterEvent(QEvent *);
    virtual void leaveEvent(QEvent *);
    virtual void paintEvent(QPaintEvent *);

private:
    Ui::CFormCamViewer *ui;


private Q_SLOTS:
    void on_btnReview_clicked();

protected:

    GstElement *pipeline;
    QPushButton *playBt;
    QPushButton *pauseBt;
    QPushButton *stopBt;
    // QWidget *videoWindow;
    QSlider *slider;
    QHBoxLayout *buttonLayout;
    QVBoxLayout *playerLayout;
    QTimer *timer;

    GstState state;
    gint64 totalDuration;
};

#endif // CFORMCAMVIEWER_H
